#include "Gra.ch"
#include "Xbp.ch"
#include "Appevent.ch"
#include "Font.ch"

#pragma library( "xppui2.lib" )

PROCEDURE AppSys()
RETURN

PROCEDURE Main
   LOCAL nEvent, mp1, mp2
   LOCAL oDlg, oXbp, drawingArea, oVideo, oStatic, oStatic2

   oDlg := XbpDialog():new(SetAppWindow():setParent(),,{250,175}, {300,250})
   oDlg:taskList := .T.
   oDlg:title    := "Animation test for BDVideo Classes"
   oDlg:visible  := .T.
   oDlg:close    := {|mp1,mp2,obj| obj:destroy() }
   oDlg:create()

   SetAppWindow( oDlg )

   drawingArea := oDlg:drawingArea
   drawingArea:setFontCompoundName( "8.Arial" )

   // Create an bdvideo object for the animation
   oAnimation := BdVideo():new(drawingArea,drawingArea,{50,150},{200,50}):create()
   oAnimation:loadfile("copy.avi")

   //Create text objects
   oStatic := XbpStatic():new(drawingArea,,{50,40},{150,50})
   oStatic:create()

   oStatic2 := XbpStatic():new(drawingArea,,{180,40},{40,50})
   oStatic2:create()

   // Create buttons
   oXbp := XbpPushButton():new( drawingArea, , {10,10}, {80,30} )
   oXbp:caption := "Play"
   oXbp:clipSiblings := .T.
   oXbp:tabStop      := .T.
   oXbp:create()
   oXbp:activate := {|| oAnimation:play(,,.T.), ;    // Play and loop the video.
                        DoStuff(oStatic,oStatic2), ; // Do other processing.
                        oAnimation:stop() }          // Stop the animation.

   oXbp := XbpPushButton():new( drawingArea, , {190,10}, {80,30} )
   oXbp:caption := "Close"
   oXbp:clipSiblings := .T.
   oXbp:tabStop      := .T.
   oXbp:create()
   oXbp:activate := {|| oAnimation:destroy(),_quit() }

   SetAppFocus(oDlg)

   DO WHILE .T.
     nEvent := AppEvent( @mp1, @mp2, @oXbp ,0)
     oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO

RETURN

FUNCTION SelectFile(cFiles)
RETURN XbpFileDialog():new():create( SetAppWindow() ):open(cFiles)

PROCEDURE DoStuff(oStatic,oStatic2)
  LOCAL I := 0
  oStatic:setCaption("I'm doing other processing: ")
  FOR I := 1 TO 100
    oStatic2:setCaption(STR(I))
    Sleep(10)
  NEXT
  oStatic2:setCaption("")
  oStatic:setCaption("I'm done! ")
RETURN